unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Math, I2C;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    temp: TLabel;
    ic_addr: TComboBox;
    com_port: TComboBox;
    Label1: TLabel;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure com_portChange(Sender: TObject);
    procedure ic_addrChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1           : TForm1;
  conversion_show : boolean;
  icaddr          : byte;

implementation

{$R *.dfm}

procedure TempStart(address : byte);
begin
  address := address shl 1;
  I2C_stop;

  I2C_start;
  I2C_tx_byte($90 + address);
  I2C_tx_byte($AC);
  I2C_tx_byte(2 + 1);
  I2C_stop;

  I2C_start;
  I2C_tx_byte($90 + address);
  I2C_tx_byte($EE);
  I2C_stop;
end;

function TempRead(address : byte; var temp : real) : boolean;
var
  done      : boolean;
  temp_int,
  temp_frac : byte;
begin
  done := true;
  address := address shl 1;

  I2C_start;
  if I2C_tx_byte($90 + address) then
    done := false;
  if I2C_tx_byte($AC) then
    done := false;
  I2C_start;
  if I2C_tx_byte($91 + address) then
    done := false;
  if I2C_rx_byte(false) and 128 = 0 then
    done := false;
  I2C_stop;

  if done then begin
    I2C_start;
    if I2C_tx_byte($90 + address) then
      done := false;
    if I2C_tx_byte($AA) then
      done := false;
    I2C_start;
    if I2C_tx_byte($91 + address) then
      done := false;
    temp_int := I2C_rx_byte(true);
    temp_frac := I2C_rx_byte(false);
    I2C_stop;
    temp := (temp_int * 256 + temp_frac) / 256;
    if temp_int >= 128 Then
      temp := temp - 256;
  end;

  TempRead := done;
end;

procedure ConversionStart;
begin
  TempStart(icaddr);
end;

procedure ConversionRead;
var
  temp : real;
  s    : string;
begin
  if TempRead(icaddr, temp) then begin
    Str(temp :0:3, s);
    Form1.temp.Caption := s + 'C';
    Application.Title := s + 'C';
  end else begin
    Form1.temp.Caption := '---.---C';
    Application.Title := '---.---C';
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if conversion_show then
    ConversionRead
  else
    conversion_show := true;
  ConversionStart;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  icaddr := Form1.ic_addr.ItemIndex;
  Open_I2C_bus(PAnsiChar(com_port.Text));
  conversion_show := false;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Close_I2C_bus;
end;

procedure TForm1.com_portChange(Sender: TObject);
begin
  Close_I2C_bus;
  Open_I2C_bus(PAnsiChar(com_port.Text));
  conversion_show := false;
end;

procedure TForm1.ic_addrChange(Sender: TObject);
begin
  conversion_show := false;
  Form1.temp.Caption := '---.---C';
  Application.Title := '---.---C';
  icaddr := Form1.ic_addr.ItemIndex;
end;

end.
